# -*- coding: utf-8 -*-
"""
Created on Tue Apr 29 10:28:39 2014

@author: andrey
"""

import gui
from RoadCentre import kernel
from PythonQt import QtGui


def editLayersOrder():
    dlg = gui.widgetFromUi('layers.ui')
    if not dlg:
        return
    layerList = dlg.findChild('QListWidget', 'layerList')
    if not layerList:
        return
    layer_count = len(kernel.graphicsScene.layers())
    if layer_count == 0:
        return

    def up_clicked():
        row = layerList.currentRow
        currentItem = layerList.takeItem(row)
        if not currentItem: return
        layerList.insertItem(row - 1, currentItem)
        layerList.currentRow = row - 1

    def down_clicked():
        row = layerList.currentRow
        currentItem = layerList.takeItem(row)
        if not currentItem: return
        layerList.insertItem(row + 1, currentItem)
        layerList.currentRow = row + 1

    dlg.findChild('QPushButton', 'up').connect('clicked()', up_clicked)
    dlg.findChild('QPushButton', 'down').connect('clicked()', down_clicked)
    layerList.currentRow = 0
    min_z = None
    max_z = None
    layers = {}
    for layer in kernel.graphicsScene.layers():
        layers[layer.z] = layer.name
        if min_z is None or layer.z < min_z:
            min_z = layer.z
        if max_z is None or layer.z > max_z:
            max_z = layer.z
    for z in sorted(layers):
        layerList.insertItem(0, layers[z])
    if getattr(dlg, 'exec')() != QtGui.QDialog.Accepted:
        return
    step_z = (max_z - min_z) / (layer_count - 1)
    z = max_z
    for i in range(layer_count):
        layer = kernel.graphicsScene.layer(layerList.item(i).text())
        if layer:
            layer.z = z
        z = z - step_z
    gui.saveLayersState()
