# -*- coding: utf-8 -*-
"""
Открытие проета:
Настройка графического интерфейса пользователя

(c)2012 ЗАО "РИПАС" и Демин Федор,
www.ripas.ru dff@ripas.ru
"""
import gui
from RoadCentre import project,kernel,plugins

gui.mainWindow.windowTitle=project.title
try:
    gui.osmView.zoomMin=int(project.settings.value('GraphicsScene/zoomMin','5'))
    gui.osmView.zoomMax=int(project.settings.value('GraphicsScene/zoomMax','20'))
    kernel.graphicsScene.setSceneRect(-118.125, 34.924, 297.723, 49.986)
    bound=project.settings.value('GraphicsScene/bound')
    if bound:
        bounds=bound.split()
        x1, y1, x2, y2 = map(float,bounds)
        gui.osmView.zoomF=10
        x, y = (x1+x2)/2,(y1+y2)/2
        gui.osmView.centerOn(x, y)
        if gui.imageView: gui.imageView.centerOn(x, y)
        if gui.osmView2: gui.osmView2.centerOn(x, y)
except:
    gui.msgError("setSceneRect error")

#from presets import loadPreset,activatePreset
#loadPreset(project.settings)
#defaultPreset=project.settings.value('DefaultPreset',None)
#if defaultPreset:
#    activatePreset(defaultPreset)
#    gui.osmView.zoomF+=0.001

if hasattr(plugins,'SpectrPlugin'):
    if project.settings.contains('lightitemsscale'):
        plugins.SpectrPlugin.setLightItemsScale(int(project.settings.value('lightitemsscale')))
    else:
        plugins.SpectrPlugin.setLightItemsScale(4000)

defaultLoaded=gui.mainWindow.findChild('QAction','defaultLoaded')
if defaultLoaded:
    import settings
    def_project=settings.value('Default/DefaultProject')
    defaultLoaded.blockSignals(True)
    defaultLoaded.checked=(def_project==project.fileName)
    defaultLoaded.blockSignals(False)
gui.projectLoaded()

